#ifndef ARCHPROFILEEDITOR_H
#define ARCHPROFILEEDITOR_H
//
#include "ui_networkprofileeditor.h"
#include <QDialog>
#include <QProcess>
#include <QPushButton>
#include <QLineEdit>
#include <QComboBox>
#include <QMap>
#include "netutils.h"

class QProcess;
class QPushButton;
class QLineEdit;
class QComboBox;
//
class ArchProfileEditor:public QDialog, public Ui::NetworkProfileEditorDialog
{
	Q_OBJECT

	public:
		ArchProfileEditor(QWidget * parent = 0, Qt::WFlags f = 0, QString profileFile = "");

	private:
		NetUtils *netUtils;
		QString editionMode;
		QString profileName;
		QString hostName;
		QString interfaceName;
		QString descriptionName;
		
		void initNewProfile();
		void initEditedProfile(QString);
		//QString checkProfileNameSyntax(const QString&);
		
		QStringList getAvailableInterfaces();
		QString getCurrentHostName();
		QMap<QString, QString> getProfileKeys(QString, QString);

	private slots:
		void profileGenerator();
		//void useDhcpStateChanged(int);
		void useDhcpStateChanged(bool);
		void pbChooseEssidClicked();
		void chooseWpaConfFileName();
		void updateBroadcastAdress(const QString&);
		void cbInterfaceNameStateChanged(const QString&);
		void cbWirelessModeStateChanged(const QString&);
		void checkLeProfileNameSyntax(const QString&);
		void quitDialog();
};
#endif
