#ifndef ARCHPROFILEWIZARD_H
#define ARCHPROFILEWIZARD_H
//
#include <QDialog>
#include <QWizard>
#include <QTreeWidget>
#include "netutils.h"
//
class QLabel;
class QComboBox;
class QCheckBox;
class QPushButton;
class QProcess;
class QTreewidget;
class QDialog;
//class QMessageBox;
//
class ArchProfileWizard : public QWizard
{
	Q_OBJECT
	
	public:
		enum { Page_Device_Selector, Page_Wifi_Selector, Page_Wifi_Parameters, Page_Connection };
		ArchProfileWizard(QWidget *parent = 0);
		//static QString toto;
		//static QString bobby();
	
	private:
		int dontLeaveMessageBox();
	
	protected:
		void closeEvent(QCloseEvent *event);
	
	private slots:
		void dontLeaveNow();
	

};

class IntroPage : public QWizardPage
{
	Q_OBJECT
	
	public:
		IntroPage(QWidget *parent = 0);
		int nextId() const;

	private:
		NetUtils *netUtils;
		QLabel *labelVendor;
		QComboBox *cbInterfaceName;
			
	private slots:
		void cbInterfaceNameStateChanged(const QString &);
};

class WifiSelectorPage : public QWizardPage
{
	Q_OBJECT
	
	public:
		WifiSelectorPage(QWidget *parent = 0);
		int nextId() const;
		bool isComplete() const;
		void initializePage();

	private:
		QLabel *statusLabel;
		QPushButton *pbRescan;
		QProcess *iwconfigProcess;
		QTreeWidget *treeWidget;
		QLineEdit *leFakeEssid;
		QLineEdit *leFakeProtocol;
		QTimer *busyTimer;
		QString busyString;
		int shot;
		bool pageComplete;
		NetUtils *netUtils;
		
		void updateTreeWidgetItems();
	
	private slots:
		void scanNetwork();
		void scanProcessEnded(int, QProcess::ExitStatus);
		void networkItemSelected();
		void timerTimeout();
};

class WifiParametersPage : public QWizardPage
{
	Q_OBJECT
	
	public:
		WifiParametersPage(QWidget *parent = 0);
		int nextId() const;
		void initializePage();

	private:
		QComboBox *cbProtocols;
		QLineEdit *leEssid;
		QLineEdit *lePwd;
	
	private slots:
		void cbProtocolsStateChanged(const QString &);
};

class ConnectionPage : public QWizardPage
{
	Q_OBJECT
	
	public:
		ConnectionPage(QWidget *parent = 0);
		int nextId() const;
		bool isComplete() const;
		void initializePage();

	private:
		QString sumup1;
		QString sumup2;
		QLabel *labelSummary;
		QPushButton *pbConnect;
		QLineEdit *leProfileName;
		QCheckBox *chStopProfiles;
		QCheckBox *chSaveProfile;
		QProcess *netcfgProcess;
		bool wizardIsComplete;
		bool pageComplete;
		NetUtils *netUtils;
		
		bool generateProfile(const QString &);
		const QString generateProfileName();
		void saveProfile();
	
	private slots:
		void editableProfileName();
		void connectionRequested();
		//void netcfgProcessEnded(int, QProcess::ExitStatus);
		void myslot();
	
	signals:
		void closeWizard();
};

class ConnectionDlg : public QDialog
{
	Q_OBJECT
	
	public:
		ConnectionDlg(QWidget *parent = 0, const QString command = "");
	
	protected:
		void closeEvent(QCloseEvent *event);
	
	private:
		int shot;
		QString busyString;
		QLabel *mainLabel;
		NetUtils *netUtils;
		QProcess *netcfgProcess;
		QPushButton *pbAbort;
		QPushButton *pbQuit;
		QTimer *busyTimer;
	
	private slots:
		void dontLeaveNow();
		void netcfgProcessEnded(int, QProcess::ExitStatus);
		void netcfgReadError();
		void timerTimeout();
		
	signals:
		void signalConnectionIsOk();
		
};
#endif
