#ifndef DIALOGIMPL_H
#define DIALOGIMPL_H
//
//#include<QtGui>
#include <QSystemTrayIcon>
#include <QProcess>
#include <QMap>
#include <QTimer>
#include "netutils.h"
//#include "archprofileconnectorthread.h"

class QAction;
class QMenu;
class QTextEdit;
class QSystemTrayIcon;
class QProcess;
class QDir;
class QSignalMapper;
//class NetUtils;
//
//class DialogImpl : public QDialog, public Ui::Dialog
class DialogImpl : public QSystemTrayIcon
{
Q_OBJECT

public:
	//DialogImpl( QWidget * parent = 0 , QString args = 0 );
	DialogImpl( QObject * parent = 0 );

private slots:
	void systemFileClicked(int);
	void systemInfoClicked(int);
	void stickyClipboardClicked(int);
	void networkProfileClicked(int);
	void networkProfileStopAllClicked();
	void networkProfileStopAllProfilesClicked();
	void networkProfileStopAllInterfacesClicked();
	void networkProfileStopOneProfileClicked(const QString &);
	void networkProfileManage();
	void networkProfileAutomatic();
	void networkProfileWizard();
	void pacmanActionClicked(int);
	void customActionClicked(int);
	void pacmanProcessEnded(int, QProcess::ExitStatus);
	void networkProfileProcessOutput();
	void networkProfileProcessEnded(int, QProcess::ExitStatus);
	void networkProfileProcessDiscoverEnded(int, QProcess::ExitStatus);
	void networkProcessStupidTimerEnded();
	void networkProfilesMenuUpdate();
	void settingsEdit();
	void customActionsEdit();
	void systemInfosListEdit();
	void systemFilesListEdit();
	void stickyClipboardListEdit();
	void showAbout();
	void systrayActivated(QSystemTrayIcon::ActivationReason);
	//void pacProcessEnded(int, QProcess::ExitStatus);
	//void pacProcessError(QProcess::ProcessError);
	//void pacProcessOutput();
	void pacProcessStart();
	void busyTimerTimeout();
	void networkProfilesCheckActive();
	void downloadFromClipboard();
	void trayLoadEject();
	
	//void ifplugdProcessOutput();

private:
	//QSystemTrayIcon *systray;
	//ArchProfileConnectorThread zeThread;
	NetUtils *netUtils;
	
	QTimer *busyTimer;
	
	QMenu *systrayMenu;
	QMenu *networkMenu;
	QMenu *networkProfilesMenu;
	QMenu *systemInfoMenu;
	QMenu *configFilesMenu;
	QMenu *pacmanMenu;
	QMenu *customActionMenu;
	QMenu *stickyClipboardMenu;
	
	//QProcess *pacProcess;
	//QProcess *customActionProcess;
	QProcess *pacmanProcess;
	QProcess *networkProfileProcess;
	QProcess *networkProfileDiscoverProcess;
	
	//QProcess *ifplugdProcess;

	bool pacmanProcessRunning;
	bool networkProcessRunning;
	bool networkProfileConnected;
	bool autoconnectOnStartup;
	bool singleProfileAtOnce;
	//bool askingConnectionFromAutoconnect;
	
	QString systrayCurrentIconName;
	QString pacmanBin;
	QString shellBin;
	QString settingsPath;
	QString settingsDir;
	QString wlanDevice;
	//QString autoconnectOnStartup;
	QString networkProfileSelected;
	//QString getEssidForProfile(QString);
	//QString getWifiInterface();
	QString fileSystemActionsList;
	QString filePacmanActionsList;
	QString fileSystemFilesList;
	QString fileCustomActionsList;
	QString fileStickyClipboardList;
	
	QStringList profileName;
	//QStringList systemFilesName;
	QMap<int, QStringList> customActionsName;
	QMap<int, QStringList> systemFilesName;
	QMap<int, QStringList> stickyClipboardName;
	//QStringList systemInfoName[50];
	QMap<int, QStringList> systemInfoName;
	QStringList pacmanAction[9];
	
	QMap<int, QStringList> readActionsList(QString);
	//QStringList getInterfacesList();
	
	//QTextEdit *pacTe;
	//int getRunningInterfacesCount();
	int matchingEssidIndex;
	int busyIndex;
	bool networkProfileStopAll();
	bool networkProfileStopAllProfiles();
	bool networkProfileStopAllInterfaces();
	void initSystray();
	void settingsRead();
	void settingsGenerate();
	//void settingsWrite();
	void systemInfosListUpdate();
	void systemFilesListUpdate();
	void customActionsListUpdate();
	void stickyClipboardListUpdate();
	void showFileErrorWarning(QString);
	void mainToolTipUpdate(const QString &);

//protected:
//	bool eventFilter(QObject *obj, QEvent *ev);
};
#endif




